 
pragma solidity ^0.4.22;

contract PKI {

    struct Cert_data{
        string hash;
        uint8 status;
        address owner;
    }
    
    mapping (uint256 => Cert_data) private db;//mapping between a uuid to a Cert_data struct
    
    function lookup(uint256 uuid) public view returns (uint8, string) {
        Cert_data memory tmp = db[uuid];
        if(tmp.status == 1) return (tmp.status, tmp.hash);
        else return (tmp.status, "");
    }
    
    function register(uint256 uuid, string cert_hash) public {
        require(db[uuid].status == 0, "uuid already register");
        Cert_data memory cert = Cert_data({hash:cert_hash, status:1, owner:msg.sender});
        db[uuid] = cert;
    }
    
    function update(uint256 uuid, string hash) public {
        require(db[uuid].owner == msg.sender, "action can only be performed by the owner");
        db[uuid].hash = hash;
    }
    
    function revoke(uint256 uuid) public {
        require(db[uuid].owner == msg.sender, "action can only be performed by the owner");
        db[uuid].status = 2;
    }
}