#!/usr/bin/env bash

trap ctrl_c INT

function ctrl_c() {
        #stop dns server
        systemctl stop dnsmasq
        kill ${ping_pid}
}

if [ "$EUID" -ne 0 ]
  then echo "Please run as root"
  exit
fi


#get local ip addr
addr=$(ip a | grep -Eo 'inet (addr:)?([0-9]*\.){3}[0-9]*' | grep -Eo '([0-9]*\.){3}[0-9]*' | grep -v '127.0.0.1')

python ping_server.py ${addr} 5005 &

ping_pid=$!

echo "-Ping server launched"

echo "${addr} controllers" >> /etc/hosts

#start dns server
systemctl start dnsmasq
systemctl enable dnsmasq
#systemctl status dnsmasq

#clean /etc/hosts
sed -i '$ d' /etc/hosts

echo "-DNS server launched"

python controller.py ${addr}
