#!/usr/bin/env bash

ip_cont=$(dig controllers | grep -oP "([0-9]{1,3}[\.]){3}[0-9]{1,3}" | head -n 1)
if [ -z "$ip_cont" ]
then
    echo "Controllers unreachable. (Check DNS address)"
    exit
fi
controller_id=$(python ping_client.py ${ip_cont} 5005)
device_uuid="12345"

var=$(head var)
FILE=./cert.pem
if [ -f "$FILE" ];
then
    openssl req -nodes -newkey rsa:4096 -keyout key_t.pem -out cert_t.csr -days 365 -config conf.cnf -extensions v3_ca -subj "/C=BE/ST=${var}/CN=${device_uuid}/1.2.3.4=${controller_id}"
    openssl x509 -req -in cert_t.csr -CA cert.pem -CAkey key.pem -CAcreateserial -extfile conf.cnf -extensions v3_ca -out cert_s.pem
    mv key_t.pem key.pem
    mv cert_s.pem cert.pem
    echo "$(($var + 1))" > var
else
    openssl req -x509 -nodes -newkey rsa:4096 -keyout key.pem -out cert.pem -days 365 -config conf.cnf -subj "/C=BE/CN=${device_uuid}/1.2.3.4=${controller_id}"
    touch var
    echo "1" > var
fi

echo "ip controller: ${ip_cont}"
curl -s -k https://${ip_cont}:4443/ --upload-file ./cert.pem
